Zoho Projects API Documentation
Text copied
File not found

Projects

This module covers project-related operations within Zoho Projects. Use this API to retrieve project activity, view or update project edits, get recent projects, manage issues and tasks, retrieve or add default visibility settings, access favorite templates or gallery templates, add projects from templates, and export custom status timelines.

Get All Projects

Retrieve a list of all projects from the Zoho Projects portal.

GET

/api/v3/portal/[PORTAL_ID]/projects

OAuth Scope:

ZohoProjects.projects.READ

Path Parameters

Param Name
Data Type
Description

Query Parameters

Param Name
Data Type
Description

Request Example

Request Example
  • cURL
  • Deluge
  • Node.js
  • Ruby
  • PHP
  • Python
  • C
  • C#
  • C++
  • Clojure
  • Go
  • HTTP
  • Java
  • JS Fetch
  • JSON
  • Kotlin
  • Objective-C
  • OCaml
  • PowerShell
  • R
  • Swift

curl -X GET \
'https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects?page=1&per_page=10&filter=%7B%22criteria%22%3A%5B%7B%22cfid%22%3A%224000000000242%22%2C%22field_name%22%3A%22project%22%2C%22criteria_condition%22%3A%22contains%22%2C%22value%22%3A%5B%221752587000000097269%22%5D%2C%22relative_columns%22%3A%5B%7B%22cfid%22%3A%224000000000242%22%2C%22field_name%22%3A%22project%22%2C%22offset%22%3A%221%22%2C%22unit%22%3A%22days%22%2C%22prior%22%3A%22before%22%7D%5D%7D%5D%2C%22pattern%22%3A%221%22%7D&sort_by=ASC%28last_modified_time%29&view_id=23806000074760021' \
-H 'Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa'

url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects";
filter_value = {"criteria":[{"cfid":"4000000000242","field_name":"project","criteria_condition":"contains","value":["1752587000000097269"],"relative_columns":[{"cfid":"4000000000242","field_name":"project","offset":"1","unit":"days","prior":"before"}]}],"pattern":"1"};
params = Map();
params.put("page", "1");
params.put("per_page", "10");
params.put("filter", filter_value);
params.put("sort_by", "ASC(last_modified_time)");
params.put("view_id", "23806000074760021");
response = invokeUrl
[
    url: url
    type: GET
    parameters: params
    connection: "projects"
];
info response;
const https = require('https');
const url = new URL('https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects');
url.searchParams.append('page', '1');
url.searchParams.append('per_page', '10');
url.searchParams.append('filter', '{"criteria":[{"cfid":"4000000000242","field_name":"project","criteria_condition":"contains","value":["1752587000000097269"],"relative_columns":[{"cfid":"4000000000242","field_name":"project","offset":"1","unit":"days","prior":"before"}]}],"pattern":"1"}');
url.searchParams.append('sort_by', 'ASC(last_modified_time)');
url.searchParams.append('view_id', '23806000074760021');

const options = {
  hostname: url.hostname,
  path: url.pathname + url.search,
  method: 'GET',
  headers: {
    'Authorization': 'Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa'
  }
};

const req = https.request(options, (res) => {
  let data = '';
  res.on('data', (chunk) => { data += chunk; });
  res.on('end', () => { console.log(JSON.parse(data)); });
});

req.on('error', (err) => { console.error(err); });
req.end();
require 'net/http'
require 'uri'
require 'json'

url = URI("https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects")
params = {
  "page" => "1",
  "per_page" => "10",
  "filter" => "{\"criteria\":[{\"cfid\":\"4000000000242\",\"field_name\":\"project\",\"criteria_condition\":\"contains\",\"value\":[\"1752587000000097269\"],\"relative_columns\":[{\"cfid\":\"4000000000242\",\"field_name\":\"project\",\"offset\":\"1\",\"unit\":\"days\",\"prior\":\"before\"}]}],\"pattern\":\"1\"}",
  "sort_by" => "ASC(last_modified_time)",
  "view_id" => "23806000074760021"
}
url.query = URI.encode_www_form(params)

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"

response = http.request(request)
puts response.read_body
<?php
$params = [
    'page' => '1',
    'per_page' => '10',
    'filter' => '{"criteria":[{"cfid":"4000000000242","field_name":"project","criteria_condition":"contains","value":["1752587000000097269"],"relative_columns":[{"cfid":"4000000000242","field_name":"project","offset":"1","unit":"days","prior":"before"}]}],"pattern":"1"}',
    'sort_by' => 'ASC(last_modified_time)',
    'view_id' => '23806000074760021',
];
$url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects" . "?" . http_build_query($params);

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => $url,
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_CUSTOMREQUEST => "GET",
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"
  ],
]);

$response = curl_exec($curl);
curl_close($curl);

echo $response;
import requests

url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects"

params = {
    "page": "1",
    "per_page": "10",
    "filter": "{\"criteria\":[{\"cfid\":\"4000000000242\",\"field_name\":\"project\",\"criteria_condition\":\"contains\",\"value\":[\"1752587000000097269\"],\"relative_columns\":[{\"cfid\":\"4000000000242\",\"field_name\":\"project\",\"offset\":\"1\",\"unit\":\"days\",\"prior\":\"before\"}]}],\"pattern\":\"1\"}",
    "sort_by": "ASC(last_modified_time)",
    "view_id": "23806000074760021"
}

headers = {
    "Authorization": "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa",
}

response = requests.get(url, headers=headers, params=params)

print(response.json())
#include <stdio.h>
#include <string.h>
#include <curl/curl.h>

int main(void) {
    CURL *curl = curl_easy_init();
    if (curl) {
        char *enc_page = curl_easy_escape(curl, "1", 0);
        char *enc_per_page = curl_easy_escape(curl, "10", 0);
        char *enc_filter = curl_easy_escape(curl, "{\"criteria\":[{\"cfid\":\"4000000000242\",\"field_name\":\"project\",\"criteria_condition\":\"contains\",\"value\":[\"1752587000000097269\"],\"relative_columns\":[{\"cfid\":\"4000000000242\",\"field_name\":\"project\",\"offset\":\"1\",\"unit\":\"days\",\"prior\":\"before\"}]}],\"pattern\":\"1\"}", 0);
        char *enc_sort_by = curl_easy_escape(curl, "ASC(last_modified_time)", 0);
        char *enc_view_id = curl_easy_escape(curl, "23806000074760021", 0);
        char url[2048];
        snprintf(url, sizeof(url), "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects?page=%s&per_page=%s&filter=%s&sort_by=%s&view_id=%s", enc_page, enc_per_page, enc_filter, enc_sort_by, enc_view_id);

        struct curl_slist *headers = NULL;
        headers = curl_slist_append(headers, "Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");

        curl_easy_setopt(curl, CURLOPT_URL, url);
        curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
        curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "GET");

        CURLcode res = curl_easy_perform(curl);
        if (res != CURLE_OK)
            fprintf(stderr, "curl failed: %s\n", curl_easy_strerror(res));

        curl_free(enc_page);
        curl_free(enc_per_page);
        curl_free(enc_filter);
        curl_free(enc_sort_by);
        curl_free(enc_view_id);
        curl_slist_free_all(headers);
        curl_easy_cleanup(curl);
    }
    return 0;
}
using System.Net.Http;
using System.Text;
using System.Web;

var client = new HttpClient();
client.DefaultRequestHeaders.Add("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");

var query = HttpUtility.ParseQueryString(string.Empty);
query["page"] = "1";
query["per_page"] = "10";
query["filter"] = "{\"criteria\":[{\"cfid\":\"4000000000242\",\"field_name\":\"project\",\"criteria_condition\":\"contains\",\"value\":[\"1752587000000097269\"],\"relative_columns\":[{\"cfid\":\"4000000000242\",\"field_name\":\"project\",\"offset\":\"1\",\"unit\":\"days\",\"prior\":\"before\"}]}],\"pattern\":\"1\"}";
query["sort_by"] = "ASC(last_modified_time)";
query["view_id"] = "23806000074760021";
var uriBuilder = new UriBuilder("https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects") { Query = query.ToString() };
var request = new HttpRequestMessage(HttpMethod.Get, uriBuilder.Uri);

var response = await client.SendAsync(request);
var body = await response.Content.ReadAsStringAsync();
Console.WriteLine(body);
#include <iostream>
#include <string>
#include <curl/curl.h>

static size_t WriteCallback(void* contents, size_t size, size_t nmemb, std::string* output) {
    output->append((char*)contents, size * nmemb);
    return size * nmemb;
}

int main() {
    CURL* curl = curl_easy_init();
    if (curl) {
        std::string response;
        char* enc_page = curl_easy_escape(curl, "1", 0);
        char* enc_per_page = curl_easy_escape(curl, "10", 0);
        char* enc_filter = curl_easy_escape(curl, "{\"criteria\":[{\"cfid\":\"4000000000242\",\"field_name\":\"project\",\"criteria_condition\":\"contains\",\"value\":[\"1752587000000097269\"],\"relative_columns\":[{\"cfid\":\"4000000000242\",\"field_name\":\"project\",\"offset\":\"1\",\"unit\":\"days\",\"prior\":\"before\"}]}],\"pattern\":\"1\"}", 0);
        char* enc_sort_by = curl_easy_escape(curl, "ASC(last_modified_time)", 0);
        char* enc_view_id = curl_easy_escape(curl, "23806000074760021", 0);
        std::string url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects";
        url += "?page=" + std::string(enc_page);
        url += "&per_page=" + std::string(enc_per_page);
        url += "&filter=" + std::string(enc_filter);
        url += "&sort_by=" + std::string(enc_sort_by);
        url += "&view_id=" + std::string(enc_view_id);

        struct curl_slist* headers = NULL;
        headers = curl_slist_append(headers, "Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");

        curl_easy_setopt(curl, CURLOPT_URL, url.c_str());
        curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
        curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "GET");
        curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, WriteCallback);
        curl_easy_setopt(curl, CURLOPT_WRITEDATA, &response);

        CURLcode res = curl_easy_perform(curl);
        if (res == CURLE_OK)
            std::cout << response << std::endl;
        else
            std::cerr << curl_easy_strerror(res) << std::endl;

        curl_free(enc_page);
        curl_free(enc_per_page);
        curl_free(enc_filter);
        curl_free(enc_sort_by);
        curl_free(enc_view_id);
        curl_slist_free_all(headers);
        curl_easy_cleanup(curl);
    }
    return 0;
}
(require '[clj-http.client :as client])

(let [enc-page (java.net.URLEncoder/encode "1" "UTF-8")
      enc-per_page (java.net.URLEncoder/encode "10" "UTF-8")
      enc-filter (java.net.URLEncoder/encode "{\"criteria\":[{\"cfid\":\"4000000000242\",\"field_name\":\"project\",\"criteria_condition\":\"contains\",\"value\":[\"1752587000000097269\"],\"relative_columns\":[{\"cfid\":\"4000000000242\",\"field_name\":\"project\",\"offset\":\"1\",\"unit\":\"days\",\"prior\":\"before\"}]}],\"pattern\":\"1\"}" "UTF-8")
      enc-sort_by (java.net.URLEncoder/encode "ASC(last_modified_time)" "UTF-8")
      enc-view_id (java.net.URLEncoder/encode "23806000074760021" "UTF-8")
      url (str "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects" "?page=" enc-page "&per_page=" enc-per_page "&filter=" enc-filter "&sort_by=" enc-sort_by "&view_id=" enc-view_id)]
(def response
  (client/get url
    {:headers {"Authorization" "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"}
     :as :json}))

(println (:body response))
package main

import (
    "fmt"
    "io"
    "net/http"
    "net/url"
)

func main() {
    req, _ := http.NewRequest("GET", "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects", nil)
    q := req.URL.Query()
    q.Add("page", "1")
    q.Add("per_page", "10")
    q.Add("filter", "{\"criteria\":[{\"cfid\":\"4000000000242\",\"field_name\":\"project\",\"criteria_condition\":\"contains\",\"value\":[\"1752587000000097269\"],\"relative_columns\":[{\"cfid\":\"4000000000242\",\"field_name\":\"project\",\"offset\":\"1\",\"unit\":\"days\",\"prior\":\"before\"}]}],\"pattern\":\"1\"}")
    q.Add("sort_by", "ASC(last_modified_time)")
    q.Add("view_id", "23806000074760021")
    req.URL.RawQuery = q.Encode()
    req.Header.Add("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa")

    resp, _ := http.DefaultClient.Do(req)
    defer resp.Body.Close()
    body, _ := io.ReadAll(resp.Body)
    fmt.Println(string(body))
}
GET https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects?page=1&per_page=10&filter=%7B%22criteria%22%3A%5B%7B%22cfid%22%3A%224000000000242%22%2C%22field_name%22%3A%22project%22%2C%22criteria_condition%22%3A%22contains%22%2C%22value%22%3A%5B%221752587000000097269%22%5D%2C%22relative_columns%22%3A%5B%7B%22cfid%22%3A%224000000000242%22%2C%22field_name%22%3A%22project%22%2C%22offset%22%3A%221%22%2C%22unit%22%3A%22days%22%2C%22prior%22%3A%22before%22%7D%5D%7D%5D%2C%22pattern%22%3A%221%22%7D&sort_by=ASC%28last_modified_time%29&view_id=23806000074760021 HTTP/1.1
Host: https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects?page=1&per_page=10&filter=%7B%22criteria%22%3A%5B%7B%22cfid%22%3A%224000000000242%22%2C%22field_name%22%3A%22project%22%2C%22criteria_condition%22%3A%22contains%22%2C%22value%22%3A%5B%221752587000000097269%22%5D%2C%22relative_columns%22%3A%5B%7B%22cfid%22%3A%224000000000242%22%2C%22field_name%22%3A%22project%22%2C%22offset%22%3A%221%22%2C%22unit%22%3A%22days%22%2C%22prior%22%3A%22before%22%7D%5D%7D%5D%2C%22pattern%22%3A%221%22%7D&sort_by=ASC%28last_modified_time%29&view_id=23806000074760021
Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa
HttpClientBuilder httpClientBuilder = HttpClientBuilder.create();

SSLContext sslContext = SSLContext.getDefault();
SSLConnectionSocketFactory sslConnectionSocketFactory = new SSLConnectionSocketFactory(sslContext, NoopHostnameVerifier.INSTANCE);
CloseableHttpClient httpclient = httpClientBuilder.setSSLSocketFactory(sslConnectionSocketFactory).build();

URIBuilder uriBuilder = new URIBuilder("https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects");
uriBuilder.addParameter("page", "1");
uriBuilder.addParameter("per_page", "10");
uriBuilder.addParameter("filter", "{\"criteria\":[{\"cfid\":\"4000000000242\",\"field_name\":\"project\",\"criteria_condition\":\"contains\",\"value\":[\"1752587000000097269\"],\"relative_columns\":[{\"cfid\":\"4000000000242\",\"field_name\":\"project\",\"offset\":\"1\",\"unit\":\"days\",\"prior\":\"before\"}]}],\"pattern\":\"1\"}");
uriBuilder.addParameter("sort_by", "ASC(last_modified_time)");
uriBuilder.addParameter("view_id", "23806000074760021");
HttpUriRequest requestObj = new HttpGet(uriBuilder.build());
requestObj.addHeader("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");

HttpResponse response = httpclient.execute(requestObj);

HttpEntity responseEntity = response.getEntity();
Object responseObject = EntityUtils.toString(responseEntity);
String responseString = responseObject.toString();
const url = 'https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects';

const params = new URLSearchParams({
  'page': '1',
  'per_page': '10',
  'filter': '{"criteria":[{"cfid":"4000000000242","field_name":"project","criteria_condition":"contains","value":["1752587000000097269"],"relative_columns":[{"cfid":"4000000000242","field_name":"project","offset":"1","unit":"days","prior":"before"}]}],"pattern":"1"}',
  'sort_by': 'ASC(last_modified_time)',
  'view_id': '23806000074760021'
});

const options = {
  method: 'GET',
  headers: {
    'Authorization': 'Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa'
  }
};

fetch(url + '?' + params.toString(), options)
  .then(response => response.json())
  .then(data => console.log(data))
  .catch(error => console.error(error));
page = "1"
per_page = "10"
filter = {"criteria":[{"cfid":"4000000000242","field_name":"project","criteria_condition":"contains","value":["1752587000000097269"],"relative_columns":[{"cfid":"4000000000242","field_name":"project","offset":"1","unit":"days","prior":"before"}]}],"pattern":"1"}
sort_by = "ASC(last_modified_time)"
view_id = "23806000074760021"
import java.net.HttpURLConnection
import java.net.URL
import okhttp3.HttpUrl.Companion.toHttpUrl

fun main() {
    val urlBuilder = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects".toHttpUrl().newBuilder()
    urlBuilder.addQueryParameter("page", "1")
    urlBuilder.addQueryParameter("per_page", "10")
    urlBuilder.addQueryParameter("filter", "{\"criteria\":[{\"cfid\":\"4000000000242\",\"field_name\":\"project\",\"criteria_condition\":\"contains\",\"value\":[\"1752587000000097269\"],\"relative_columns\":[{\"cfid\":\"4000000000242\",\"field_name\":\"project\",\"offset\":\"1\",\"unit\":\"days\",\"prior\":\"before\"}]}],\"pattern\":\"1\"}")
    urlBuilder.addQueryParameter("sort_by", "ASC(last_modified_time)")
    urlBuilder.addQueryParameter("view_id", "23806000074760021")
    val url = URL(urlBuilder.build().toString())
    val conn = url.openConnection() as HttpURLConnection
    conn.requestMethod = "GET"
    conn.setRequestProperty("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa")

    val response = conn.inputStream.bufferedReader().readText()
    println(response)
}
NSString *encodedPage = [@"1" stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];
NSString *encodedPer_page = [@"10" stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];
NSString *encodedFilter = [@"{\"criteria\":[{\"cfid\":\"4000000000242\",\"field_name\":\"project\",\"criteria_condition\":\"contains\",\"value\":[\"1752587000000097269\"],\"relative_columns\":[{\"cfid\":\"4000000000242\",\"field_name\":\"project\",\"offset\":\"1\",\"unit\":\"days\",\"prior\":\"before\"}]}],\"pattern\":\"1\"}" stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];
NSString *encodedSort_by = [@"ASC(last_modified_time)" stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];
NSString *encodedView_id = [@"23806000074760021" stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];
NSString *urlString = [NSString stringWithFormat:@"https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects?page=%@&per_page=%@&filter=%@&sort_by=%@&view_id=%@", encodedPage, encodedPer_page, encodedFilter, encodedSort_by, encodedView_id];
NSURL *url = [NSURL URLWithString:urlString];
NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:url];
[request setHTTPMethod:@"GET"];
[request setValue:@"Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa" forHTTPHeaderField:@"Authorization"];

NSURLSession *session = [NSURLSession sharedSession];
NSURLSessionDataTask *task = [session dataTaskWithRequest:request
    completionHandler:^(NSData *data, NSURLResponse *response, NSError *error) {
        NSString *result = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
        NSLog(@"%@", result);
}];
[task resume];
open Lwt
open Cohttp_lwt_unix

let () =
  let enc_page = Uri.pct_encode "1" in
  let enc_per_page = Uri.pct_encode "10" in
  let enc_filter = Uri.pct_encode "{\"criteria\":[{\"cfid\":\"4000000000242\",\"field_name\":\"project\",\"criteria_condition\":\"contains\",\"value\":[\"1752587000000097269\"],\"relative_columns\":[{\"cfid\":\"4000000000242\",\"field_name\":\"project\",\"offset\":\"1\",\"unit\":\"days\",\"prior\":\"before\"}]}],\"pattern\":\"1\"}" in
  let enc_sort_by = Uri.pct_encode "ASC(last_modified_time)" in
  let enc_view_id = Uri.pct_encode "23806000074760021" in
  let uri = Uri.of_string ("https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects" ^ "?page=" ^ enc_page ^ "&per_page=" ^ enc_per_page ^ "&filter=" ^ enc_filter ^ "&sort_by=" ^ enc_sort_by ^ "&view_id=" ^ enc_view_id) in
  let headers = Cohttp.Header.init ()
    |> fun h -> Cohttp.Header.add h "Authorization" "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"
  in
  Lwt_main.run (
    Client.get ~headers uri >>= fun (_, body) ->
    Cohttp_lwt.Body.to_string body >|= fun s ->
    print_endline s)
$headers = @{
    "Authorization" = "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"
}

$params = @{
    page = "1"
    per_page = "10"
    filter = "{`"criteria`":[{`"cfid`":`"4000000000242`",`"field_name`":`"project`",`"criteria_condition`":`"contains`",`"value`":[`"1752587000000097269`"],`"relative_columns`":[{`"cfid`":`"4000000000242`",`"field_name`":`"project`",`"offset`":`"1`",`"unit`":`"days`",`"prior`":`"before`"}]}],`"pattern`":`"1`"}"
    sort_by = "ASC(last_modified_time)"
    view_id = "23806000074760021"
}
$queryString = ($params.GetEnumerator() | ForEach-Object { "$($_.Key)=$([System.Uri]::EscapeDataString($_.Value))" }) -join "&"
$url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects" + "?" + $queryString

$response = Invoke-RestMethod -Uri $url -Method GET -Headers $headers

$response | ConvertTo-Json
library(httr)

url <- "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects"

params <- list(
  page = "1",
  per_page = "10",
  filter = "{\"criteria\":[{\"cfid\":\"4000000000242\",\"field_name\":\"project\",\"criteria_condition\":\"contains\",\"value\":[\"1752587000000097269\"],\"relative_columns\":[{\"cfid\":\"4000000000242\",\"field_name\":\"project\",\"offset\":\"1\",\"unit\":\"days\",\"prior\":\"before\"}]}],\"pattern\":\"1\"}",
  sort_by = "ASC(last_modified_time)",
  view_id = "23806000074760021"
)

response <- GET(
  url,
  add_headers(Authorization = "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"),
  query = params
)

content(response, "text")
import Foundation

var components = URLComponents(string: "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects")!
components.queryItems = [
    URLQueryItem(name: "page", value: "1"),
    URLQueryItem(name: "per_page", value: "10"),
    URLQueryItem(name: "filter", value: "{\"criteria\":[{\"cfid\":\"4000000000242\",\"field_name\":\"project\",\"criteria_condition\":\"contains\",\"value\":[\"1752587000000097269\"],\"relative_columns\":[{\"cfid\":\"4000000000242\",\"field_name\":\"project\",\"offset\":\"1\",\"unit\":\"days\",\"prior\":\"before\"}]}],\"pattern\":\"1\"}"),
    URLQueryItem(name: "sort_by", value: "ASC(last_modified_time)"),
    URLQueryItem(name: "view_id", value: "23806000074760021")
]
let url = components.url!
var request = URLRequest(url: url)
request.httpMethod = "GET"
request.setValue("Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa", forHTTPHeaderField: "Authorization")

let semaphore = DispatchSemaphore(value: 0)
let task = URLSession.shared.dataTask(with: request) { data, response, error in
    if let data = data, let result = String(data: data, encoding: .utf8) {
        print(result)
    }
    semaphore.signal()
}
task.resume()
semaphore.wait()

Sample Input

page : "1" per_page : "10" filter : { "criteria" : [ { "cfid" : "4000000000242", "field_name" : "project", "criteria_condition" : "contains", "value" : [ "1752587000000097269" ], "relative_columns" : [ { "cfid" : "4000000000242", "field_name" : "project", "offset" : "1", "unit" : "days", "prior" : "before" } ] } ], "pattern" : "1" } sort_by : "ASC(last_modified_time)" view_id : "23806000074760021"

Sample Response

200[ { "id" : "7000000082003", "name" : "Website Redesign", "key" : "54", "description" : "Redesign the company website with new branding", "project_type" : "active", "start_date" : "2024-09-30", "end_date" : "2025-06-30", "is_public_project" : "false", "is_strict_project" : "false", "is_rollup_project" : "false", "is_completed" : "false", "is_linked_project" : "false", "percent_complete" : 45, "color" : "#4573d2", "comments_count" : 12, "owner" : { "id" : "6000000002069", "zpuid" : "7000000002083", "name" : "Patricia Boyle", "email" : "patricia.boyle@zylker.com" }, "status" : { "id" : "7000000000361", "name" : "In Progress", "color" : "green", "color_hexcode" : "#3cb371", "is_closed_type" : "false", "is_default" : "false" }, "layout" : { "id" : "7000000000305", "name" : "Standard Layout", "is_default" : "true", "type" : "public" }, "tasks" : { "open_count" : 15, "closed_count" : 10 }, "issues" : { "open_count" : 5, "closed_count" : 3 }, "milestones" : { "open_count" : 2, "closed_count" : 1 }, "created_by" : { "id" : "6000000002069", "zpuid" : "7000000002083", "name" : "Patricia Boyle", "email" : "patricia.boyle@zylker.com" }, "created_time" : "2024-09-30T10:30:00.000Z", "updated_by" : { "id" : "6000000002069", "zpuid" : "7000000002083", "name" : "Patricia Boyle", "email" : "patricia.boyle@zylker.com" }, "modified_time" : "2025-01-15T14:20:00.000Z" } ]

Possible Errors

Get Project Details

Retrieve details of a project.

GET

/api/v3/portal/[PORTAL_ID]/projects/[PROJECT_ID]

OAuth Scope:

ZohoProjects.projects.READ

Path Parameters

Param Name
Data Type
Description

Request Example

Request Example
  • cURL
  • Deluge
  • Node.js
  • Ruby
  • PHP
  • Python
  • C
  • C#
  • C++
  • Clojure
  • Go
  • HTTP
  • Java
  • JS Fetch
  • Kotlin
  • Objective-C
  • OCaml
  • PowerShell
  • R
  • Swift

curl -X GET \
'https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166' \
-H 'Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa'

url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166";
response = invokeUrl
[
    url: url
    type: GET
    connection: "projects"
];
info response;
const https = require('https');
const url = new URL('https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166');

const options = {
  hostname: url.hostname,
  path: url.pathname + url.search,
  method: 'GET',
  headers: {
    'Authorization': 'Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa'
  }
};

const req = https.request(options, (res) => {
  let data = '';
  res.on('data', (chunk) => { data += chunk; });
  res.on('end', () => { console.log(JSON.parse(data)); });
});

req.on('error', (err) => { console.error(err); });
req.end();
require 'net/http'
require 'uri'
require 'json'

url = URI("https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"

response = http.request(request)
puts response.read_body
<?php
$url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166";

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => $url,
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_CUSTOMREQUEST => "GET",
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"
  ],
]);

$response = curl_exec($curl);
curl_close($curl);

echo $response;
import requests

url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166"

headers = {
    "Authorization": "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa",
}

response = requests.get(url, headers=headers)

print(response.json())
#include <stdio.h>
#include <string.h>
#include <curl/curl.h>

int main(void) {
    CURL *curl = curl_easy_init();
    if (curl) {
        struct curl_slist *headers = NULL;
        headers = curl_slist_append(headers, "Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");

        curl_easy_setopt(curl, CURLOPT_URL, "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166");
        curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
        curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "GET");

        CURLcode res = curl_easy_perform(curl);
        if (res != CURLE_OK)
            fprintf(stderr, "curl failed: %s\n", curl_easy_strerror(res));

        curl_slist_free_all(headers);
        curl_easy_cleanup(curl);
    }
    return 0;
}
using System.Net.Http;
using System.Text;
using System.Web;

var client = new HttpClient();
client.DefaultRequestHeaders.Add("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");

var request = new HttpRequestMessage(HttpMethod.Get, "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166");

var response = await client.SendAsync(request);
var body = await response.Content.ReadAsStringAsync();
Console.WriteLine(body);
#include <iostream>
#include <string>
#include <curl/curl.h>

static size_t WriteCallback(void* contents, size_t size, size_t nmemb, std::string* output) {
    output->append((char*)contents, size * nmemb);
    return size * nmemb;
}

int main() {
    CURL* curl = curl_easy_init();
    if (curl) {
        std::string response;
        struct curl_slist* headers = NULL;
        headers = curl_slist_append(headers, "Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");

        curl_easy_setopt(curl, CURLOPT_URL, "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166");
        curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
        curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "GET");
        curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, WriteCallback);
        curl_easy_setopt(curl, CURLOPT_WRITEDATA, &response);

        CURLcode res = curl_easy_perform(curl);
        if (res == CURLE_OK)
            std::cout << response << std::endl;
        else
            std::cerr << curl_easy_strerror(res) << std::endl;

        curl_slist_free_all(headers);
        curl_easy_cleanup(curl);
    }
    return 0;
}
(require '[clj-http.client :as client])

(def response
  (client/get "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166"
    {:headers {"Authorization" "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"}
     :as :json}))

(println (:body response))
package main

import (
    "fmt"
    "io"
    "net/http"
)

func main() {
    req, _ := http.NewRequest("GET", "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166", nil)
    req.Header.Add("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa")

    resp, _ := http.DefaultClient.Do(req)
    defer resp.Body.Close()
    body, _ := io.ReadAll(resp.Body)
    fmt.Println(string(body))
}
GET https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166 HTTP/1.1
Host: https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166
Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa
HttpClientBuilder httpClientBuilder = HttpClientBuilder.create();

SSLContext sslContext = SSLContext.getDefault();
SSLConnectionSocketFactory sslConnectionSocketFactory = new SSLConnectionSocketFactory(sslContext, NoopHostnameVerifier.INSTANCE);
CloseableHttpClient httpclient = httpClientBuilder.setSSLSocketFactory(sslConnectionSocketFactory).build();

URIBuilder uriBuilder = new URIBuilder("https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166");
HttpUriRequest requestObj = new HttpGet(uriBuilder.build());
requestObj.addHeader("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");

HttpResponse response = httpclient.execute(requestObj);

HttpEntity responseEntity = response.getEntity();
Object responseObject = EntityUtils.toString(responseEntity);
String responseString = responseObject.toString();
const url = 'https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166';

const options = {
  method: 'GET',
  headers: {
    'Authorization': 'Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa'
  }
};

fetch(url, options)
  .then(response => response.json())
  .then(data => console.log(data))
  .catch(error => console.error(error));
import java.net.HttpURLConnection
import java.net.URL
import okhttp3.HttpUrl.Companion.toHttpUrl

fun main() {
    val url = URL("https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166")
    val conn = url.openConnection() as HttpURLConnection
    conn.requestMethod = "GET"
    conn.setRequestProperty("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa")

    val response = conn.inputStream.bufferedReader().readText()
    println(response)
}
NSURL *url = [NSURL URLWithString:@"https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166"];
NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:url];
[request setHTTPMethod:@"GET"];
[request setValue:@"Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa" forHTTPHeaderField:@"Authorization"];

NSURLSession *session = [NSURLSession sharedSession];
NSURLSessionDataTask *task = [session dataTaskWithRequest:request
    completionHandler:^(NSData *data, NSURLResponse *response, NSError *error) {
        NSString *result = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
        NSLog(@"%@", result);
}];
[task resume];
open Lwt
open Cohttp_lwt_unix

let () =
  let uri = Uri.of_string "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166" in
  let headers = Cohttp.Header.init ()
    |> fun h -> Cohttp.Header.add h "Authorization" "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"
  in
  Lwt_main.run (
    Client.get ~headers uri >>= fun (_, body) ->
    Cohttp_lwt.Body.to_string body >|= fun s ->
    print_endline s)
$headers = @{
    "Authorization" = "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"
}

$response = Invoke-RestMethod -Uri "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166" -Method GET -Headers $headers

$response | ConvertTo-Json
library(httr)

url <- "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166"

response <- GET(
  url,
  add_headers(Authorization = "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa")
)

content(response, "text")
import Foundation

let url = URL(string: "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166")!
var request = URLRequest(url: url)
request.httpMethod = "GET"
request.setValue("Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa", forHTTPHeaderField: "Authorization")

let semaphore = DispatchSemaphore(value: 0)
let task = URLSession.shared.dataTask(with: request) { data, response, error in
    if let data = data, let result = String(data: data, encoding: .utf8) {
        print(result)
    }
    semaphore.signal()
}
task.resume()
semaphore.wait()

Sample Response

200{ "end_date" : "2029-01-01", "picklist_11sep" : "abc", "is_public_project" : "false", "description" : "source project  for testing clone project", "is_strict_project" : "false", "multiline_11sep" : "multiline \nMULTILINE", "budget_info" : { "hourly_budget" : "1200:00", "billing_method" : "project_hours", "forecasted_cost" : { "amount" : 0.0, "formatted_amount" : "$ 0.00", "currency_code" : "USD", "currency_id" : "7000000015018" }, "planned_hours" : "00:00", "bcy_forecasted_cost" : { "amount" : 0.0, "formatted_amount" : "$ 0.00", "currency_code" : "USD", "currency_id" : "7000000015018" }, "forecasted_hours" : "00:00", "remaining_hours" : "00:00", "actual_cost" : { "amount" : 0.0, "formatted_amount" : "$ 0.00", "currency_code" : "USD", "currency_id" : "7000000015018" }, "actual_hours" : "00:00", "bcy_planned_cost" : { "amount" : 0.0, "formatted_amount" : "$ 0.00", "currency_code" : "USD", "currency_id" : "7000000015018" }, "planned_cost" : { "amount" : 0.0, "formatted_amount" : "$ 0.00", "currency_code" : "USD", "currency_id" : "7000000015018" }, "budget_type" : "based_on_project", "bcy_actual_cost" : { "amount" : 0.0, "formatted_amount" : "$ 0.00", "currency_code" : "USD", "currency_id" : "7000000015018" }, "cost_budget" : { "amount" : "10000000", "formatted_amount" : "$ 1,00,00,000.00", "currency_code" : "USD", "currency_id" : "7000000015018" } }, "issues" : { "closed_count" : 0, "open_count" : 0 }, "is_completed" : "false", "id" : "7000000010005", "key" : "5", "tasks" : { "closed_count" : 0, "open_count" : 5 }, "number_11sep" : "1212", "start_date" : "2024-09-30", "phone_11sep" : "9879879877", "project_type" : "active", "created_time" : "2024-09-02T08:04:09.657Z", "check_box_sample_11sep" : "true", "is_rollup_project" : "true", "one" : "123456_single", "created_by" : { "zpuid" : "7000000002411", "name" : "Daniel", "last_name" : "Cooper", "first_name" : "Daniel", "zuid" : "25450833" }, "percent_complete" : "0", "tags" : [ { "id" : "7000000015084", "color_hexcode" : "#7dcf7b" } ], "layout" : { "name" : "Standard Layout", "id" : "7000000000506", "is_default" : "true", "type" : "public" }, "completed_time" : "1767099600000", "single_line_test_1446" : "singleline", "name" : "SourceP", "updated_by" : { "zpuid" : "7000000002411", "name" : "Daniel", "last_name" : "Cooper", "first_name" : "Daniel", "zuid" : "25450833" }, "project_group" : { "name" : "zp.projset.ungroupproj", "id" : "7000000005369", "type" : "public" }, "milestones" : { "closed_count" : 0, "open_count" : 0 }, "status" : { "is_closed_type" : "false", "name" : "Active", "id" : "7000000000665" } }

Create Project

Create a new project in the Zoho Projects portal.

POST

/api/v3/portal/[PORTAL_ID]/projects

OAuth Scope:

ZohoProjects.projects.CREATE

Path Parameters

Param Name
Data Type
Description

Body Parameters

Param Name
Data Type
Description

Request Example

Request Example
  • cURL
  • Deluge
  • Node.js
  • Ruby
  • PHP
  • Python
  • C
  • C#
  • C++
  • Clojure
  • Go
  • HTTP
  • Java
  • JS Fetch
  • JSON
  • Kotlin
  • Objective-C
  • OCaml
  • PowerShell
  • R
  • Swift

curl -X POST \
'https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects' \
-H 'Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa' \
-H 'Content-Type: application/json' \
-d '{"name":"Website Redesign","description":"Redesign the company website with new branding","project_type":"active","owner":{"zpuid":"4000000002055"},"is_public_project":false,"start_date":"2023-12-20","end_date":"2024-12-20","status":{"id":"4000000062001"},"layout":{"id":"4000000062001"},"added_via":"api","is_rollup_project":false,"budget_info":{"billing_method":"project_hours","budget_type":"based_on_project","tracking_method":"project_hours","currency":"USD","cost_budget":{"amount":50000.0},"hourly_budget":"30:00","rate_per_hour":{"amount":945.25},"cost_budget_threshold":{"amount":50000.0},"hourly_budget_threshold":"20:00","fixed_cost":{"amount":50000.0},"cost_per_hour":{"amount":510.75},"revenue_budget":{"amount":50000.0}},"project_group":{"id":"4000000062001"},"tags":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"business_hours_id":"7000000197013"}'

url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects";
params = Map();
params.put("name", "Website Redesign");
params.put("description", "Redesign the company website with new branding");
params.put("project_type", "active");
params.put("owner", {"zpuid":"4000000002055"});
params.put("is_public_project", false);
params.put("start_date", "2023-12-20");
params.put("end_date", "2024-12-20");
params.put("status", {"id":"4000000062001"});
params.put("layout", {"id":"4000000062001"});
params.put("added_via", "api");
params.put("is_rollup_project", false);
params.put("budget_info", {"billing_method":"project_hours","budget_type":"based_on_project","tracking_method":"project_hours","currency":"USD","cost_budget":{"amount":50000.0},"hourly_budget":"30:00","rate_per_hour":{"amount":945.25},"cost_budget_threshold":{"amount":50000.0},"hourly_budget_threshold":"20:00","fixed_cost":{"amount":50000.0},"cost_per_hour":{"amount":510.75},"revenue_budget":{"amount":50000.0}});
params.put("project_group", {"id":"4000000062001"});
params.put("tags", [{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}]);
params.put("business_hours_id", "7000000197013");
response = invokeUrl
[
    url: url
    type: POST
    parameters: params.toString()
    connection: "projects"
];
info response;
const https = require('https');
const url = new URL('https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects');

const payload = JSON.stringify({"name":"Website Redesign","description":"Redesign the company website with new branding","project_type":"active","owner":{"zpuid":"4000000002055"},"is_public_project":false,"start_date":"2023-12-20","end_date":"2024-12-20","status":{"id":"4000000062001"},"layout":{"id":"4000000062001"},"added_via":"api","is_rollup_project":false,"budget_info":{"billing_method":"project_hours","budget_type":"based_on_project","tracking_method":"project_hours","currency":"USD","cost_budget":{"amount":50000.0},"hourly_budget":"30:00","rate_per_hour":{"amount":945.25},"cost_budget_threshold":{"amount":50000.0},"hourly_budget_threshold":"20:00","fixed_cost":{"amount":50000.0},"cost_per_hour":{"amount":510.75},"revenue_budget":{"amount":50000.0}},"project_group":{"id":"4000000062001"},"tags":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"business_hours_id":"7000000197013"});

const options = {
  hostname: url.hostname,
  path: url.pathname + url.search,
  method: 'POST',
  headers: {
    'Authorization': 'Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa',
    'Content-Type': 'application/json',
    'Content-Length': Buffer.byteLength(payload)
  }
};

const req = https.request(options, (res) => {
  let data = '';
  res.on('data', (chunk) => { data += chunk; });
  res.on('end', () => { console.log(JSON.parse(data)); });
});

req.on('error', (err) => { console.error(err); });
req.write(payload);
req.end();
require 'net/http'
require 'uri'
require 'json'

url = URI("https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"
request["Content-Type"] = "application/json"
request.body = '{"name":"Website Redesign","description":"Redesign the company website with new branding","project_type":"active","owner":{"zpuid":"4000000002055"},"is_public_project":false,"start_date":"2023-12-20","end_date":"2024-12-20","status":{"id":"4000000062001"},"layout":{"id":"4000000062001"},"added_via":"api","is_rollup_project":false,"budget_info":{"billing_method":"project_hours","budget_type":"based_on_project","tracking_method":"project_hours","currency":"USD","cost_budget":{"amount":50000.0},"hourly_budget":"30:00","rate_per_hour":{"amount":945.25},"cost_budget_threshold":{"amount":50000.0},"hourly_budget_threshold":"20:00","fixed_cost":{"amount":50000.0},"cost_per_hour":{"amount":510.75},"revenue_budget":{"amount":50000.0}},"project_group":{"id":"4000000062001"},"tags":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"business_hours_id":"7000000197013"}'

response = http.request(request)
puts response.read_body
<?php
$url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects";

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => $url,
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => '{"name":"Website Redesign","description":"Redesign the company website with new branding","project_type":"active","owner":{"zpuid":"4000000002055"},"is_public_project":false,"start_date":"2023-12-20","end_date":"2024-12-20","status":{"id":"4000000062001"},"layout":{"id":"4000000062001"},"added_via":"api","is_rollup_project":false,"budget_info":{"billing_method":"project_hours","budget_type":"based_on_project","tracking_method":"project_hours","currency":"USD","cost_budget":{"amount":50000.0},"hourly_budget":"30:00","rate_per_hour":{"amount":945.25},"cost_budget_threshold":{"amount":50000.0},"hourly_budget_threshold":"20:00","fixed_cost":{"amount":50000.0},"cost_per_hour":{"amount":510.75},"revenue_budget":{"amount":50000.0}},"project_group":{"id":"4000000062001"},"tags":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"business_hours_id":"7000000197013"}',
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa",
    "Content-Type: application/json"
  ],
]);

$response = curl_exec($curl);
curl_close($curl);

echo $response;
import requests

url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects"

headers = {
    "Authorization": "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa",
    "Content-Type": "application/json",
}

payload = '{"name":"Website Redesign","description":"Redesign the company website with new branding","project_type":"active","owner":{"zpuid":"4000000002055"},"is_public_project":false,"start_date":"2023-12-20","end_date":"2024-12-20","status":{"id":"4000000062001"},"layout":{"id":"4000000062001"},"added_via":"api","is_rollup_project":false,"budget_info":{"billing_method":"project_hours","budget_type":"based_on_project","tracking_method":"project_hours","currency":"USD","cost_budget":{"amount":50000.0},"hourly_budget":"30:00","rate_per_hour":{"amount":945.25},"cost_budget_threshold":{"amount":50000.0},"hourly_budget_threshold":"20:00","fixed_cost":{"amount":50000.0},"cost_per_hour":{"amount":510.75},"revenue_budget":{"amount":50000.0}},"project_group":{"id":"4000000062001"},"tags":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"business_hours_id":"7000000197013"}'

response = requests.post(url, headers=headers, data=payload)

print(response.json())
#include <stdio.h>
#include <string.h>
#include <curl/curl.h>

int main(void) {
    CURL *curl = curl_easy_init();
    if (curl) {
        struct curl_slist *headers = NULL;
        headers = curl_slist_append(headers, "Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");
        headers = curl_slist_append(headers, "Content-Type: application/json");

        curl_easy_setopt(curl, CURLOPT_URL, "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects");
        curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
        curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "POST");
        curl_easy_setopt(curl, CURLOPT_POSTFIELDS, "{\"name\":\"Website Redesign\",\"description\":\"Redesign the company website with new branding\",\"project_type\":\"active\",\"owner\":{\"zpuid\":\"4000000002055\"},\"is_public_project\":false,\"start_date\":\"2023-12-20\",\"end_date\":\"2024-12-20\",\"status\":{\"id\":\"4000000062001\"},\"layout\":{\"id\":\"4000000062001\"},\"added_via\":\"api\",\"is_rollup_project\":false,\"budget_info\":{\"billing_method\":\"project_hours\",\"budget_type\":\"based_on_project\",\"tracking_method\":\"project_hours\",\"currency\":\"USD\",\"cost_budget\":{\"amount\":50000.0},\"hourly_budget\":\"30:00\",\"rate_per_hour\":{\"amount\":945.25},\"cost_budget_threshold\":{\"amount\":50000.0},\"hourly_budget_threshold\":\"20:00\",\"fixed_cost\":{\"amount\":50000.0},\"cost_per_hour\":{\"amount\":510.75},\"revenue_budget\":{\"amount\":50000.0}},\"project_group\":{\"id\":\"4000000062001\"},\"tags\":[{\"add\":[{\"id\":\"4000000062001\"}],\"remove\":[{\"id\":\"4000000062001\"}],\"id\":\"4000000062001\"}],\"business_hours_id\":\"7000000197013\"}");

        CURLcode res = curl_easy_perform(curl);
        if (res != CURLE_OK)
            fprintf(stderr, "curl failed: %s\n", curl_easy_strerror(res));

        curl_slist_free_all(headers);
        curl_easy_cleanup(curl);
    }
    return 0;
}
using System.Net.Http;
using System.Text;
using System.Web;

var client = new HttpClient();
client.DefaultRequestHeaders.Add("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");

var request = new HttpRequestMessage(HttpMethod.Post, "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects");
request.Content = new StringContent(
    @"{""name"":""Website Redesign"",""description"":""Redesign the company website with new branding"",""project_type"":""active"",""owner"":{""zpuid"":""4000000002055""},""is_public_project"":false,""start_date"":""2023-12-20"",""end_date"":""2024-12-20"",""status"":{""id"":""4000000062001""},""layout"":{""id"":""4000000062001""},""added_via"":""api"",""is_rollup_project"":false,""budget_info"":{""billing_method"":""project_hours"",""budget_type"":""based_on_project"",""tracking_method"":""project_hours"",""currency"":""USD"",""cost_budget"":{""amount"":50000.0},""hourly_budget"":""30:00"",""rate_per_hour"":{""amount"":945.25},""cost_budget_threshold"":{""amount"":50000.0},""hourly_budget_threshold"":""20:00"",""fixed_cost"":{""amount"":50000.0},""cost_per_hour"":{""amount"":510.75},""revenue_budget"":{""amount"":50000.0}},""project_group"":{""id"":""4000000062001""},""tags"":[{""add"":[{""id"":""4000000062001""}],""remove"":[{""id"":""4000000062001""}],""id"":""4000000062001""}],""business_hours_id"":""7000000197013""}",
    Encoding.UTF8,
    "application/json"
);

var response = await client.SendAsync(request);
var body = await response.Content.ReadAsStringAsync();
Console.WriteLine(body);
#include <iostream>
#include <string>
#include <curl/curl.h>

static size_t WriteCallback(void* contents, size_t size, size_t nmemb, std::string* output) {
    output->append((char*)contents, size * nmemb);
    return size * nmemb;
}

int main() {
    CURL* curl = curl_easy_init();
    if (curl) {
        std::string response;
        struct curl_slist* headers = NULL;
        headers = curl_slist_append(headers, "Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");
        headers = curl_slist_append(headers, "Content-Type: application/json");

        curl_easy_setopt(curl, CURLOPT_URL, "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects");
        curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
        curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "POST");
        curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, WriteCallback);
        curl_easy_setopt(curl, CURLOPT_WRITEDATA, &response);
        curl_easy_setopt(curl, CURLOPT_POSTFIELDS, "{\"name\":\"Website Redesign\",\"description\":\"Redesign the company website with new branding\",\"project_type\":\"active\",\"owner\":{\"zpuid\":\"4000000002055\"},\"is_public_project\":false,\"start_date\":\"2023-12-20\",\"end_date\":\"2024-12-20\",\"status\":{\"id\":\"4000000062001\"},\"layout\":{\"id\":\"4000000062001\"},\"added_via\":\"api\",\"is_rollup_project\":false,\"budget_info\":{\"billing_method\":\"project_hours\",\"budget_type\":\"based_on_project\",\"tracking_method\":\"project_hours\",\"currency\":\"USD\",\"cost_budget\":{\"amount\":50000.0},\"hourly_budget\":\"30:00\",\"rate_per_hour\":{\"amount\":945.25},\"cost_budget_threshold\":{\"amount\":50000.0},\"hourly_budget_threshold\":\"20:00\",\"fixed_cost\":{\"amount\":50000.0},\"cost_per_hour\":{\"amount\":510.75},\"revenue_budget\":{\"amount\":50000.0}},\"project_group\":{\"id\":\"4000000062001\"},\"tags\":[{\"add\":[{\"id\":\"4000000062001\"}],\"remove\":[{\"id\":\"4000000062001\"}],\"id\":\"4000000062001\"}],\"business_hours_id\":\"7000000197013\"}");

        CURLcode res = curl_easy_perform(curl);
        if (res == CURLE_OK)
            std::cout << response << std::endl;
        else
            std::cerr << curl_easy_strerror(res) << std::endl;

        curl_slist_free_all(headers);
        curl_easy_cleanup(curl);
    }
    return 0;
}
(require '[clj-http.client :as client])

(def response
  (client/post "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects"
    {:headers {"Authorization" "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"
                "Content-Type" "application/json"}
     :body "{\"name\":\"Website Redesign\",\"description\":\"Redesign the company website with new branding\",\"project_type\":\"active\",\"owner\":{\"zpuid\":\"4000000002055\"},\"is_public_project\":false,\"start_date\":\"2023-12-20\",\"end_date\":\"2024-12-20\",\"status\":{\"id\":\"4000000062001\"},\"layout\":{\"id\":\"4000000062001\"},\"added_via\":\"api\",\"is_rollup_project\":false,\"budget_info\":{\"billing_method\":\"project_hours\",\"budget_type\":\"based_on_project\",\"tracking_method\":\"project_hours\",\"currency\":\"USD\",\"cost_budget\":{\"amount\":50000.0},\"hourly_budget\":\"30:00\",\"rate_per_hour\":{\"amount\":945.25},\"cost_budget_threshold\":{\"amount\":50000.0},\"hourly_budget_threshold\":\"20:00\",\"fixed_cost\":{\"amount\":50000.0},\"cost_per_hour\":{\"amount\":510.75},\"revenue_budget\":{\"amount\":50000.0}},\"project_group\":{\"id\":\"4000000062001\"},\"tags\":[{\"add\":[{\"id\":\"4000000062001\"}],\"remove\":[{\"id\":\"4000000062001\"}],\"id\":\"4000000062001\"}],\"business_hours_id\":\"7000000197013\"}"
     :as :json}))

(println (:body response))
package main

import (
    "fmt"
    "io"
    "net/http"
    "strings"
)

func main() {
    payload := strings.NewReader("{\"name\":\"Website Redesign\",\"description\":\"Redesign the company website with new branding\",\"project_type\":\"active\",\"owner\":{\"zpuid\":\"4000000002055\"},\"is_public_project\":false,\"start_date\":\"2023-12-20\",\"end_date\":\"2024-12-20\",\"status\":{\"id\":\"4000000062001\"},\"layout\":{\"id\":\"4000000062001\"},\"added_via\":\"api\",\"is_rollup_project\":false,\"budget_info\":{\"billing_method\":\"project_hours\",\"budget_type\":\"based_on_project\",\"tracking_method\":\"project_hours\",\"currency\":\"USD\",\"cost_budget\":{\"amount\":50000.0},\"hourly_budget\":\"30:00\",\"rate_per_hour\":{\"amount\":945.25},\"cost_budget_threshold\":{\"amount\":50000.0},\"hourly_budget_threshold\":\"20:00\",\"fixed_cost\":{\"amount\":50000.0},\"cost_per_hour\":{\"amount\":510.75},\"revenue_budget\":{\"amount\":50000.0}},\"project_group\":{\"id\":\"4000000062001\"},\"tags\":[{\"add\":[{\"id\":\"4000000062001\"}],\"remove\":[{\"id\":\"4000000062001\"}],\"id\":\"4000000062001\"}],\"business_hours_id\":\"7000000197013\"}")
    req, _ := http.NewRequest("POST", "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects", payload)
    req.Header.Add("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa")
    req.Header.Add("Content-Type", "application/json")

    resp, _ := http.DefaultClient.Do(req)
    defer resp.Body.Close()
    body, _ := io.ReadAll(resp.Body)
    fmt.Println(string(body))
}
POST https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects HTTP/1.1
Host: https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects
Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa
Content-Type: application/json

{"name":"Website Redesign","description":"Redesign the company website with new branding","project_type":"active","owner":{"zpuid":"4000000002055"},"is_public_project":false,"start_date":"2023-12-20","end_date":"2024-12-20","status":{"id":"4000000062001"},"layout":{"id":"4000000062001"},"added_via":"api","is_rollup_project":false,"budget_info":{"billing_method":"project_hours","budget_type":"based_on_project","tracking_method":"project_hours","currency":"USD","cost_budget":{"amount":50000.0},"hourly_budget":"30:00","rate_per_hour":{"amount":945.25},"cost_budget_threshold":{"amount":50000.0},"hourly_budget_threshold":"20:00","fixed_cost":{"amount":50000.0},"cost_per_hour":{"amount":510.75},"revenue_budget":{"amount":50000.0}},"project_group":{"id":"4000000062001"},"tags":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"business_hours_id":"7000000197013"}
HttpClientBuilder httpClientBuilder = HttpClientBuilder.create();

SSLContext sslContext = SSLContext.getDefault();
SSLConnectionSocketFactory sslConnectionSocketFactory = new SSLConnectionSocketFactory(sslContext, NoopHostnameVerifier.INSTANCE);
CloseableHttpClient httpclient = httpClientBuilder.setSSLSocketFactory(sslConnectionSocketFactory).build();

URIBuilder uriBuilder = new URIBuilder("https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects");
HttpUriRequest requestObj = new HttpPost(uriBuilder.build());
requestObj.addHeader("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");

HttpEntityEnclosingRequestBase requestBase = (HttpEntityEnclosingRequestBase) requestObj;
String requestBody = "{\"name\":\"Website Redesign\",\"description\":\"Redesign the company website with new branding\",\"project_type\":\"active\",\"owner\":{\"zpuid\":\"4000000002055\"},\"is_public_project\":false,\"start_date\":\"2023-12-20\",\"end_date\":\"2024-12-20\",\"status\":{\"id\":\"4000000062001\"},\"layout\":{\"id\":\"4000000062001\"},\"added_via\":\"api\",\"is_rollup_project\":false,\"budget_info\":{\"billing_method\":\"project_hours\",\"budget_type\":\"based_on_project\",\"tracking_method\":\"project_hours\",\"currency\":\"USD\",\"cost_budget\":{\"amount\":50000.0},\"hourly_budget\":\"30:00\",\"rate_per_hour\":{\"amount\":945.25},\"cost_budget_threshold\":{\"amount\":50000.0},\"hourly_budget_threshold\":\"20:00\",\"fixed_cost\":{\"amount\":50000.0},\"cost_per_hour\":{\"amount\":510.75},\"revenue_budget\":{\"amount\":50000.0}},\"project_group\":{\"id\":\"4000000062001\"},\"tags\":[{\"add\":[{\"id\":\"4000000062001\"}],\"remove\":[{\"id\":\"4000000062001\"}],\"id\":\"4000000062001\"}],\"business_hours_id\":\"7000000197013\"}";
requestBase.setEntity(new StringEntity(requestBody, HTTP.UTF_8));

HttpResponse response = httpclient.execute(requestObj);

HttpEntity responseEntity = response.getEntity();
Object responseObject = EntityUtils.toString(responseEntity);
String responseString = responseObject.toString();
const url = 'https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects';

const options = {
  method: 'POST',
  headers: {
    'Authorization': 'Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa',
    'Content-Type': 'application/json'
  },
  body: JSON.stringify({"name":"Website Redesign","description":"Redesign the company website with new branding","project_type":"active","owner":{"zpuid":"4000000002055"},"is_public_project":false,"start_date":"2023-12-20","end_date":"2024-12-20","status":{"id":"4000000062001"},"layout":{"id":"4000000062001"},"added_via":"api","is_rollup_project":false,"budget_info":{"billing_method":"project_hours","budget_type":"based_on_project","tracking_method":"project_hours","currency":"USD","cost_budget":{"amount":50000.0},"hourly_budget":"30:00","rate_per_hour":{"amount":945.25},"cost_budget_threshold":{"amount":50000.0},"hourly_budget_threshold":"20:00","fixed_cost":{"amount":50000.0},"cost_per_hour":{"amount":510.75},"revenue_budget":{"amount":50000.0}},"project_group":{"id":"4000000062001"},"tags":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"business_hours_id":"7000000197013"})
};

fetch(url, options)
  .then(response => response.json())
  .then(data => console.log(data))
  .catch(error => console.error(error));
{"name":"Website Redesign","description":"Redesign the company website with new branding","project_type":"active","owner":{"zpuid":"4000000002055"},"is_public_project":false,"start_date":"2023-12-20","end_date":"2024-12-20","status":{"id":"4000000062001"},"layout":{"id":"4000000062001"},"added_via":"api","is_rollup_project":false,"budget_info":{"billing_method":"project_hours","budget_type":"based_on_project","tracking_method":"project_hours","currency":"USD","cost_budget":{"amount":50000.0},"hourly_budget":"30:00","rate_per_hour":{"amount":945.25},"cost_budget_threshold":{"amount":50000.0},"hourly_budget_threshold":"20:00","fixed_cost":{"amount":50000.0},"cost_per_hour":{"amount":510.75},"revenue_budget":{"amount":50000.0}},"project_group":{"id":"4000000062001"},"tags":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"business_hours_id":"7000000197013"}
import java.net.HttpURLConnection
import java.net.URL
import okhttp3.HttpUrl.Companion.toHttpUrl

fun main() {
    val url = URL("https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects")
    val conn = url.openConnection() as HttpURLConnection
    conn.requestMethod = "POST"
    conn.setRequestProperty("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa")
    conn.setRequestProperty("Content-Type", "application/json")
    conn.doOutput = true
    conn.outputStream.bufferedWriter().use { it.write("""{"name":"Website Redesign","description":"Redesign the company website with new branding","project_type":"active","owner":{"zpuid":"4000000002055"},"is_public_project":false,"start_date":"2023-12-20","end_date":"2024-12-20","status":{"id":"4000000062001"},"layout":{"id":"4000000062001"},"added_via":"api","is_rollup_project":false,"budget_info":{"billing_method":"project_hours","budget_type":"based_on_project","tracking_method":"project_hours","currency":"USD","cost_budget":{"amount":50000.0},"hourly_budget":"30:00","rate_per_hour":{"amount":945.25},"cost_budget_threshold":{"amount":50000.0},"hourly_budget_threshold":"20:00","fixed_cost":{"amount":50000.0},"cost_per_hour":{"amount":510.75},"revenue_budget":{"amount":50000.0}},"project_group":{"id":"4000000062001"},"tags":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"business_hours_id":"7000000197013"}""") }

    val response = conn.inputStream.bufferedReader().readText()
    println(response)
}
NSURL *url = [NSURL URLWithString:@"https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects"];
NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:url];
[request setHTTPMethod:@"POST"];
[request setValue:@"Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa" forHTTPHeaderField:@"Authorization"];
[request setValue:@"application/json" forHTTPHeaderField:@"Content-Type"];
NSData *body = [@"{\"name\":\"Website Redesign\",\"description\":\"Redesign the company website with new branding\",\"project_type\":\"active\",\"owner\":{\"zpuid\":\"4000000002055\"},\"is_public_project\":false,\"start_date\":\"2023-12-20\",\"end_date\":\"2024-12-20\",\"status\":{\"id\":\"4000000062001\"},\"layout\":{\"id\":\"4000000062001\"},\"added_via\":\"api\",\"is_rollup_project\":false,\"budget_info\":{\"billing_method\":\"project_hours\",\"budget_type\":\"based_on_project\",\"tracking_method\":\"project_hours\",\"currency\":\"USD\",\"cost_budget\":{\"amount\":50000.0},\"hourly_budget\":\"30:00\",\"rate_per_hour\":{\"amount\":945.25},\"cost_budget_threshold\":{\"amount\":50000.0},\"hourly_budget_threshold\":\"20:00\",\"fixed_cost\":{\"amount\":50000.0},\"cost_per_hour\":{\"amount\":510.75},\"revenue_budget\":{\"amount\":50000.0}},\"project_group\":{\"id\":\"4000000062001\"},\"tags\":[{\"add\":[{\"id\":\"4000000062001\"}],\"remove\":[{\"id\":\"4000000062001\"}],\"id\":\"4000000062001\"}],\"business_hours_id\":\"7000000197013\"}" dataUsingEncoding:NSUTF8StringEncoding];
[request setHTTPBody:body];

NSURLSession *session = [NSURLSession sharedSession];
NSURLSessionDataTask *task = [session dataTaskWithRequest:request
    completionHandler:^(NSData *data, NSURLResponse *response, NSError *error) {
        NSString *result = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
        NSLog(@"%@", result);
}];
[task resume];
open Lwt
open Cohttp_lwt_unix

let () =
  let uri = Uri.of_string "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects" in
  let headers = Cohttp.Header.init ()
    |> fun h -> Cohttp.Header.add h "Authorization" "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"
    |> fun h -> Cohttp.Header.add h "Content-Type" "application/json"
  in
  let body = Cohttp_lwt.Body.of_string {json|{"name":"Website Redesign","description":"Redesign the company website with new branding","project_type":"active","owner":{"zpuid":"4000000002055"},"is_public_project":false,"start_date":"2023-12-20","end_date":"2024-12-20","status":{"id":"4000000062001"},"layout":{"id":"4000000062001"},"added_via":"api","is_rollup_project":false,"budget_info":{"billing_method":"project_hours","budget_type":"based_on_project","tracking_method":"project_hours","currency":"USD","cost_budget":{"amount":50000.0},"hourly_budget":"30:00","rate_per_hour":{"amount":945.25},"cost_budget_threshold":{"amount":50000.0},"hourly_budget_threshold":"20:00","fixed_cost":{"amount":50000.0},"cost_per_hour":{"amount":510.75},"revenue_budget":{"amount":50000.0}},"project_group":{"id":"4000000062001"},"tags":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"business_hours_id":"7000000197013"}|json} in
  Lwt_main.run (
    Client.post ~headers ~body uri >>= fun (_, body) ->
    Cohttp_lwt.Body.to_string body >|= fun s ->
    print_endline s)
$headers = @{
    "Authorization" = "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"
    "Content-Type" = "application/json"
}

$body = @'
{"name":"Website Redesign","description":"Redesign the company website with new branding","project_type":"active","owner":{"zpuid":"4000000002055"},"is_public_project":false,"start_date":"2023-12-20","end_date":"2024-12-20","status":{"id":"4000000062001"},"layout":{"id":"4000000062001"},"added_via":"api","is_rollup_project":false,"budget_info":{"billing_method":"project_hours","budget_type":"based_on_project","tracking_method":"project_hours","currency":"USD","cost_budget":{"amount":50000.0},"hourly_budget":"30:00","rate_per_hour":{"amount":945.25},"cost_budget_threshold":{"amount":50000.0},"hourly_budget_threshold":"20:00","fixed_cost":{"amount":50000.0},"cost_per_hour":{"amount":510.75},"revenue_budget":{"amount":50000.0}},"project_group":{"id":"4000000062001"},"tags":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"business_hours_id":"7000000197013"}
'@

$response = Invoke-RestMethod -Uri "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects" -Method POST -Headers $headers -Body $body

$response | ConvertTo-Json
library(httr)

url <- "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects"

response <- POST(
  url,
  add_headers(Authorization = "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"),
  content_type_json(),
  body = "{\"name\":\"Website Redesign\",\"description\":\"Redesign the company website with new branding\",\"project_type\":\"active\",\"owner\":{\"zpuid\":\"4000000002055\"},\"is_public_project\":false,\"start_date\":\"2023-12-20\",\"end_date\":\"2024-12-20\",\"status\":{\"id\":\"4000000062001\"},\"layout\":{\"id\":\"4000000062001\"},\"added_via\":\"api\",\"is_rollup_project\":false,\"budget_info\":{\"billing_method\":\"project_hours\",\"budget_type\":\"based_on_project\",\"tracking_method\":\"project_hours\",\"currency\":\"USD\",\"cost_budget\":{\"amount\":50000.0},\"hourly_budget\":\"30:00\",\"rate_per_hour\":{\"amount\":945.25},\"cost_budget_threshold\":{\"amount\":50000.0},\"hourly_budget_threshold\":\"20:00\",\"fixed_cost\":{\"amount\":50000.0},\"cost_per_hour\":{\"amount\":510.75},\"revenue_budget\":{\"amount\":50000.0}},\"project_group\":{\"id\":\"4000000062001\"},\"tags\":[{\"add\":[{\"id\":\"4000000062001\"}],\"remove\":[{\"id\":\"4000000062001\"}],\"id\":\"4000000062001\"}],\"business_hours_id\":\"7000000197013\"}"
)

content(response, "text")
import Foundation

let url = URL(string: "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects")!
var request = URLRequest(url: url)
request.httpMethod = "POST"
request.setValue("Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa", forHTTPHeaderField: "Authorization")
request.setValue("application/json", forHTTPHeaderField: "Content-Type")
request.httpBody = """
{"name":"Website Redesign","description":"Redesign the company website with new branding","project_type":"active","owner":{"zpuid":"4000000002055"},"is_public_project":false,"start_date":"2023-12-20","end_date":"2024-12-20","status":{"id":"4000000062001"},"layout":{"id":"4000000062001"},"added_via":"api","is_rollup_project":false,"budget_info":{"billing_method":"project_hours","budget_type":"based_on_project","tracking_method":"project_hours","currency":"USD","cost_budget":{"amount":50000.0},"hourly_budget":"30:00","rate_per_hour":{"amount":945.25},"cost_budget_threshold":{"amount":50000.0},"hourly_budget_threshold":"20:00","fixed_cost":{"amount":50000.0},"cost_per_hour":{"amount":510.75},"revenue_budget":{"amount":50000.0}},"project_group":{"id":"4000000062001"},"tags":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"business_hours_id":"7000000197013"}
""".data(using: .utf8)

let semaphore = DispatchSemaphore(value: 0)
let task = URLSession.shared.dataTask(with: request) { data, response, error in
    if let data = data, let result = String(data: data, encoding: .utf8) {
        print(result)
    }
    semaphore.signal()
}
task.resume()
semaphore.wait()

Sample Input

Content-Type: application/json
{ "name" : "Website Redesign", "description" : "Redesign the company website with new branding", "project_type" : "active", "owner" : { "zpuid" : "4000000002055" }, "is_public_project" : false, "start_date" : "2023-12-20", "end_date" : "2024-12-20", "status" : { "id" : "4000000062001" }, "layout" : { "id" : "4000000062001" }, "added_via" : "api", "is_rollup_project" : false, "budget_info" : { "billing_method" : "project_hours", "budget_type" : "based_on_project", "tracking_method" : "project_hours", "currency" : "USD", "cost_budget" : { "amount" : 50000.0 }, "hourly_budget" : "30:00", "rate_per_hour" : { "amount" : 945.25 }, "cost_budget_threshold" : { "amount" : 50000.0 }, "hourly_budget_threshold" : "20:00", "fixed_cost" : { "amount" : 50000.0 }, "cost_per_hour" : { "amount" : 510.75 }, "revenue_budget" : { "amount" : 50000.0 } }, "project_group" : { "id" : "4000000062001" }, "tags" : [ { "add" : [ { "id" : "4000000062001" } ], "remove" : [ { "id" : "4000000062001" } ], "id" : "4000000062001" } ], "business_hours_id" : "7000000197013" }

Sample Response

200{ "end_date" : "2029-01-01", "picklist_11sep" : "abc", "is_public_project" : "false", "description" : "source project  for testing clone project", "is_strict_project" : "false", "multiline_11sep" : "multiline \nMULTILINE", "budget_info" : { "hourly_budget" : "1200:00", "billing_method" : "project_hours", "forecasted_cost" : { "amount" : 50000.0, "formatted_amount" : "$ 50000.00", "currency_code" : "USD", "currency_id" : "7000000015018" }, "planned_hours" : "20:00", "bcy_forecasted_cost" : { "amount" : 50000.0, "formatted_amount" : "$ 50000.00", "currency_code" : "USD", "currency_id" : "7000000015018" }, "forecasted_hours" : "20:00", "remaining_hours" : "10:00", "actual_cost" : { "amount" : 50000.0, "formatted_amount" : "$ 50000.00", "currency_code" : "USD", "currency_id" : "7000000015018" }, "actual_hours" : "50:00", "bcy_planned_cost" : { "amount" : 50000.0, "formatted_amount" : "$ 50000.00", "currency_code" : "USD", "currency_id" : "7000000015018" }, "planned_cost" : { "amount" : 50000.0, "formatted_amount" : "$ 50000.00", "currency_code" : "USD", "currency_id" : "7000000015018" }, "budget_type" : "based_on_project", "bcy_actual_cost" : { "amount" : 50000.0, "formatted_amount" : "$ 50000.00", "currency_code" : "USD", "currency_id" : "7000000015018" }, "cost_budget" : { "amount" : "10000000", "formatted_amount" : "$ 1,00,00,000.00", "currency_code" : "USD", "currency_id" : "7000000015018" } }, "issues" : { "closed_count" : 10, "open_count" : 10 }, "is_completed" : "false", "id" : "7000000074003", "key" : "50", "tasks" : { "closed_count" : 10, "open_count" : 10 }, "number_11sep" : "1212", "start_date" : "2024-09-30", "phone_11sep" : "9879879877", "project_type" : "active", "created_time" : "2024-11-22T01:31:18.811Z", "check_box_sample_11sep" : "true", "is_rollup_project" : "false", "one" : "123456_single", "created_by" : { "zpuid" : "7000000002411", "name" : "Daniel", "last_name" : "Cooper", "first_name" : "Daniel", "zuid" : "25450833" }, "percent_complete" : "10", "tags" : [ { "id" : "7000000015084", "color_hexcode" : "#7dcf7b" } ], "layout" : { "name" : "Standard Layout", "id" : "7000000000506", "is_default" : "true", "type" : "public" }, "single_line_test_1446" : "singleline", "name" : "via_api_created_002_22nov_1230PM", "updated_by" : { "zpuid" : "7000000002411", "name" : "Daniel", "last_name" : "Cooper", "first_name" : "Daniel", "zuid" : "25450833" }, "project_group" : { "name" : "zp.projset.ungroupproj", "id" : "7000000005369", "type" : "public" }, "milestones" : { "closed_count" : 10, "open_count" : 10 }, "status" : { "is_closed_type" : "false", "name" : "Active", "id" : "7000000000665" } }

Update Project

Modify details of an existing project.

PATCH

/api/v3/portal/[PORTAL_ID]/projects/[PROJECT_ID]

OAuth Scope:

ZohoProjects.projects.UPDATE

Path Parameters

Param Name
Data Type
Description

Body Parameters

Param Name
Data Type
Description

Request Example

Request Example
  • cURL
  • Deluge
  • Node.js
  • Ruby
  • PHP
  • Python
  • C
  • C#
  • C++
  • Clojure
  • Go
  • HTTP
  • Java
  • JS Fetch
  • JSON
  • Kotlin
  • Objective-C
  • OCaml
  • PowerShell
  • R
  • Swift

curl -X PATCH \
'https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166' \
-H 'Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa' \
-H 'Content-Type: application/json' \
-d '{"name":"Website Redesign","description":"Redesign the company website with new branding","project_type":"active","owner":{"zpuid":"4000000002055"},"is_public_project":false,"start_date":"2023-12-20","end_date":"2024-12-20","completed_time":"2025-12-30T18:30:00.000Z","status":{"id":"4000000062001"},"layout":{"id":"4000000062001"},"added_via":"api","is_rollup_project":false,"budget_info":{"billing_method":"project_hours","budget_type":"based_on_project","tracking_method":"project_hours","currency":"USD","cost_budget":{"amount":50000.0},"hourly_budget":"30:00","rate_per_hour":{"amount":945.25},"cost_budget_threshold":{"amount":50000.0},"hourly_budget_threshold":"20:00","fixed_cost":{"amount":50000.0},"cost_per_hour":{"amount":510.75},"revenue_budget":{"amount":50000.0}},"project_group":{"id":"4000000062001"},"tags":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"color":"#4573d2","business_hours_id":"7000000197013"}'

url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166";
params = Map();
params.put("name", "Website Redesign");
params.put("description", "Redesign the company website with new branding");
params.put("project_type", "active");
params.put("owner", {"zpuid":"4000000002055"});
params.put("is_public_project", false);
params.put("start_date", "2023-12-20");
params.put("end_date", "2024-12-20");
params.put("completed_time", "2025-12-30T18:30:00.000Z");
params.put("status", {"id":"4000000062001"});
params.put("layout", {"id":"4000000062001"});
params.put("added_via", "api");
params.put("is_rollup_project", false);
params.put("budget_info", {"billing_method":"project_hours","budget_type":"based_on_project","tracking_method":"project_hours","currency":"USD","cost_budget":{"amount":50000.0},"hourly_budget":"30:00","rate_per_hour":{"amount":945.25},"cost_budget_threshold":{"amount":50000.0},"hourly_budget_threshold":"20:00","fixed_cost":{"amount":50000.0},"cost_per_hour":{"amount":510.75},"revenue_budget":{"amount":50000.0}});
params.put("project_group", {"id":"4000000062001"});
params.put("tags", [{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}]);
params.put("color", "#4573d2");
params.put("business_hours_id", "7000000197013");
response = invokeUrl
[
    url: url
    type: PATCH
    parameters: params.toString()
    connection: "projects"
];
info response;
const https = require('https');
const url = new URL('https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166');

const payload = JSON.stringify({"name":"Website Redesign","description":"Redesign the company website with new branding","project_type":"active","owner":{"zpuid":"4000000002055"},"is_public_project":false,"start_date":"2023-12-20","end_date":"2024-12-20","completed_time":"2025-12-30T18:30:00.000Z","status":{"id":"4000000062001"},"layout":{"id":"4000000062001"},"added_via":"api","is_rollup_project":false,"budget_info":{"billing_method":"project_hours","budget_type":"based_on_project","tracking_method":"project_hours","currency":"USD","cost_budget":{"amount":50000.0},"hourly_budget":"30:00","rate_per_hour":{"amount":945.25},"cost_budget_threshold":{"amount":50000.0},"hourly_budget_threshold":"20:00","fixed_cost":{"amount":50000.0},"cost_per_hour":{"amount":510.75},"revenue_budget":{"amount":50000.0}},"project_group":{"id":"4000000062001"},"tags":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"color":"#4573d2","business_hours_id":"7000000197013"});

const options = {
  hostname: url.hostname,
  path: url.pathname + url.search,
  method: 'PATCH',
  headers: {
    'Authorization': 'Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa',
    'Content-Type': 'application/json',
    'Content-Length': Buffer.byteLength(payload)
  }
};

const req = https.request(options, (res) => {
  let data = '';
  res.on('data', (chunk) => { data += chunk; });
  res.on('end', () => { console.log(JSON.parse(data)); });
});

req.on('error', (err) => { console.error(err); });
req.write(payload);
req.end();
require 'net/http'
require 'uri'
require 'json'

url = URI("https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Patch.new(url)
request["Authorization"] = "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"
request["Content-Type"] = "application/json"
request.body = '{"name":"Website Redesign","description":"Redesign the company website with new branding","project_type":"active","owner":{"zpuid":"4000000002055"},"is_public_project":false,"start_date":"2023-12-20","end_date":"2024-12-20","completed_time":"2025-12-30T18:30:00.000Z","status":{"id":"4000000062001"},"layout":{"id":"4000000062001"},"added_via":"api","is_rollup_project":false,"budget_info":{"billing_method":"project_hours","budget_type":"based_on_project","tracking_method":"project_hours","currency":"USD","cost_budget":{"amount":50000.0},"hourly_budget":"30:00","rate_per_hour":{"amount":945.25},"cost_budget_threshold":{"amount":50000.0},"hourly_budget_threshold":"20:00","fixed_cost":{"amount":50000.0},"cost_per_hour":{"amount":510.75},"revenue_budget":{"amount":50000.0}},"project_group":{"id":"4000000062001"},"tags":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"color":"#4573d2","business_hours_id":"7000000197013"}'

response = http.request(request)
puts response.read_body
<?php
$url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166";

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => $url,
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_CUSTOMREQUEST => "PATCH",
  CURLOPT_POSTFIELDS => '{"name":"Website Redesign","description":"Redesign the company website with new branding","project_type":"active","owner":{"zpuid":"4000000002055"},"is_public_project":false,"start_date":"2023-12-20","end_date":"2024-12-20","completed_time":"2025-12-30T18:30:00.000Z","status":{"id":"4000000062001"},"layout":{"id":"4000000062001"},"added_via":"api","is_rollup_project":false,"budget_info":{"billing_method":"project_hours","budget_type":"based_on_project","tracking_method":"project_hours","currency":"USD","cost_budget":{"amount":50000.0},"hourly_budget":"30:00","rate_per_hour":{"amount":945.25},"cost_budget_threshold":{"amount":50000.0},"hourly_budget_threshold":"20:00","fixed_cost":{"amount":50000.0},"cost_per_hour":{"amount":510.75},"revenue_budget":{"amount":50000.0}},"project_group":{"id":"4000000062001"},"tags":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"color":"#4573d2","business_hours_id":"7000000197013"}',
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa",
    "Content-Type: application/json"
  ],
]);

$response = curl_exec($curl);
curl_close($curl);

echo $response;
import requests

url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166"

headers = {
    "Authorization": "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa",
    "Content-Type": "application/json",
}

payload = '{"name":"Website Redesign","description":"Redesign the company website with new branding","project_type":"active","owner":{"zpuid":"4000000002055"},"is_public_project":false,"start_date":"2023-12-20","end_date":"2024-12-20","completed_time":"2025-12-30T18:30:00.000Z","status":{"id":"4000000062001"},"layout":{"id":"4000000062001"},"added_via":"api","is_rollup_project":false,"budget_info":{"billing_method":"project_hours","budget_type":"based_on_project","tracking_method":"project_hours","currency":"USD","cost_budget":{"amount":50000.0},"hourly_budget":"30:00","rate_per_hour":{"amount":945.25},"cost_budget_threshold":{"amount":50000.0},"hourly_budget_threshold":"20:00","fixed_cost":{"amount":50000.0},"cost_per_hour":{"amount":510.75},"revenue_budget":{"amount":50000.0}},"project_group":{"id":"4000000062001"},"tags":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"color":"#4573d2","business_hours_id":"7000000197013"}'

response = requests.patch(url, headers=headers, data=payload)

print(response.json())
#include <stdio.h>
#include <string.h>
#include <curl/curl.h>

int main(void) {
    CURL *curl = curl_easy_init();
    if (curl) {
        struct curl_slist *headers = NULL;
        headers = curl_slist_append(headers, "Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");
        headers = curl_slist_append(headers, "Content-Type: application/json");

        curl_easy_setopt(curl, CURLOPT_URL, "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166");
        curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
        curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "PATCH");
        curl_easy_setopt(curl, CURLOPT_POSTFIELDS, "{\"name\":\"Website Redesign\",\"description\":\"Redesign the company website with new branding\",\"project_type\":\"active\",\"owner\":{\"zpuid\":\"4000000002055\"},\"is_public_project\":false,\"start_date\":\"2023-12-20\",\"end_date\":\"2024-12-20\",\"completed_time\":\"2025-12-30T18:30:00.000Z\",\"status\":{\"id\":\"4000000062001\"},\"layout\":{\"id\":\"4000000062001\"},\"added_via\":\"api\",\"is_rollup_project\":false,\"budget_info\":{\"billing_method\":\"project_hours\",\"budget_type\":\"based_on_project\",\"tracking_method\":\"project_hours\",\"currency\":\"USD\",\"cost_budget\":{\"amount\":50000.0},\"hourly_budget\":\"30:00\",\"rate_per_hour\":{\"amount\":945.25},\"cost_budget_threshold\":{\"amount\":50000.0},\"hourly_budget_threshold\":\"20:00\",\"fixed_cost\":{\"amount\":50000.0},\"cost_per_hour\":{\"amount\":510.75},\"revenue_budget\":{\"amount\":50000.0}},\"project_group\":{\"id\":\"4000000062001\"},\"tags\":[{\"add\":[{\"id\":\"4000000062001\"}],\"remove\":[{\"id\":\"4000000062001\"}],\"id\":\"4000000062001\"}],\"color\":\"#4573d2\",\"business_hours_id\":\"7000000197013\"}");

        CURLcode res = curl_easy_perform(curl);
        if (res != CURLE_OK)
            fprintf(stderr, "curl failed: %s\n", curl_easy_strerror(res));

        curl_slist_free_all(headers);
        curl_easy_cleanup(curl);
    }
    return 0;
}
using System.Net.Http;
using System.Text;
using System.Web;

var client = new HttpClient();
client.DefaultRequestHeaders.Add("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");

var request = new HttpRequestMessage(HttpMethod.Patch, "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166");
request.Content = new StringContent(
    @"{""name"":""Website Redesign"",""description"":""Redesign the company website with new branding"",""project_type"":""active"",""owner"":{""zpuid"":""4000000002055""},""is_public_project"":false,""start_date"":""2023-12-20"",""end_date"":""2024-12-20"",""completed_time"":""2025-12-30T18:30:00.000Z"",""status"":{""id"":""4000000062001""},""layout"":{""id"":""4000000062001""},""added_via"":""api"",""is_rollup_project"":false,""budget_info"":{""billing_method"":""project_hours"",""budget_type"":""based_on_project"",""tracking_method"":""project_hours"",""currency"":""USD"",""cost_budget"":{""amount"":50000.0},""hourly_budget"":""30:00"",""rate_per_hour"":{""amount"":945.25},""cost_budget_threshold"":{""amount"":50000.0},""hourly_budget_threshold"":""20:00"",""fixed_cost"":{""amount"":50000.0},""cost_per_hour"":{""amount"":510.75},""revenue_budget"":{""amount"":50000.0}},""project_group"":{""id"":""4000000062001""},""tags"":[{""add"":[{""id"":""4000000062001""}],""remove"":[{""id"":""4000000062001""}],""id"":""4000000062001""}],""color"":""#4573d2"",""business_hours_id"":""7000000197013""}",
    Encoding.UTF8,
    "application/json"
);

var response = await client.SendAsync(request);
var body = await response.Content.ReadAsStringAsync();
Console.WriteLine(body);
#include <iostream>
#include <string>
#include <curl/curl.h>

static size_t WriteCallback(void* contents, size_t size, size_t nmemb, std::string* output) {
    output->append((char*)contents, size * nmemb);
    return size * nmemb;
}

int main() {
    CURL* curl = curl_easy_init();
    if (curl) {
        std::string response;
        struct curl_slist* headers = NULL;
        headers = curl_slist_append(headers, "Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");
        headers = curl_slist_append(headers, "Content-Type: application/json");

        curl_easy_setopt(curl, CURLOPT_URL, "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166");
        curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
        curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "PATCH");
        curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, WriteCallback);
        curl_easy_setopt(curl, CURLOPT_WRITEDATA, &response);
        curl_easy_setopt(curl, CURLOPT_POSTFIELDS, "{\"name\":\"Website Redesign\",\"description\":\"Redesign the company website with new branding\",\"project_type\":\"active\",\"owner\":{\"zpuid\":\"4000000002055\"},\"is_public_project\":false,\"start_date\":\"2023-12-20\",\"end_date\":\"2024-12-20\",\"completed_time\":\"2025-12-30T18:30:00.000Z\",\"status\":{\"id\":\"4000000062001\"},\"layout\":{\"id\":\"4000000062001\"},\"added_via\":\"api\",\"is_rollup_project\":false,\"budget_info\":{\"billing_method\":\"project_hours\",\"budget_type\":\"based_on_project\",\"tracking_method\":\"project_hours\",\"currency\":\"USD\",\"cost_budget\":{\"amount\":50000.0},\"hourly_budget\":\"30:00\",\"rate_per_hour\":{\"amount\":945.25},\"cost_budget_threshold\":{\"amount\":50000.0},\"hourly_budget_threshold\":\"20:00\",\"fixed_cost\":{\"amount\":50000.0},\"cost_per_hour\":{\"amount\":510.75},\"revenue_budget\":{\"amount\":50000.0}},\"project_group\":{\"id\":\"4000000062001\"},\"tags\":[{\"add\":[{\"id\":\"4000000062001\"}],\"remove\":[{\"id\":\"4000000062001\"}],\"id\":\"4000000062001\"}],\"color\":\"#4573d2\",\"business_hours_id\":\"7000000197013\"}");

        CURLcode res = curl_easy_perform(curl);
        if (res == CURLE_OK)
            std::cout << response << std::endl;
        else
            std::cerr << curl_easy_strerror(res) << std::endl;

        curl_slist_free_all(headers);
        curl_easy_cleanup(curl);
    }
    return 0;
}
(require '[clj-http.client :as client])

(def response
  (client/patch "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166"
    {:headers {"Authorization" "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"
                "Content-Type" "application/json"}
     :body "{\"name\":\"Website Redesign\",\"description\":\"Redesign the company website with new branding\",\"project_type\":\"active\",\"owner\":{\"zpuid\":\"4000000002055\"},\"is_public_project\":false,\"start_date\":\"2023-12-20\",\"end_date\":\"2024-12-20\",\"completed_time\":\"2025-12-30T18:30:00.000Z\",\"status\":{\"id\":\"4000000062001\"},\"layout\":{\"id\":\"4000000062001\"},\"added_via\":\"api\",\"is_rollup_project\":false,\"budget_info\":{\"billing_method\":\"project_hours\",\"budget_type\":\"based_on_project\",\"tracking_method\":\"project_hours\",\"currency\":\"USD\",\"cost_budget\":{\"amount\":50000.0},\"hourly_budget\":\"30:00\",\"rate_per_hour\":{\"amount\":945.25},\"cost_budget_threshold\":{\"amount\":50000.0},\"hourly_budget_threshold\":\"20:00\",\"fixed_cost\":{\"amount\":50000.0},\"cost_per_hour\":{\"amount\":510.75},\"revenue_budget\":{\"amount\":50000.0}},\"project_group\":{\"id\":\"4000000062001\"},\"tags\":[{\"add\":[{\"id\":\"4000000062001\"}],\"remove\":[{\"id\":\"4000000062001\"}],\"id\":\"4000000062001\"}],\"color\":\"#4573d2\",\"business_hours_id\":\"7000000197013\"}"
     :as :json}))

(println (:body response))
package main

import (
    "fmt"
    "io"
    "net/http"
    "strings"
)

func main() {
    payload := strings.NewReader("{\"name\":\"Website Redesign\",\"description\":\"Redesign the company website with new branding\",\"project_type\":\"active\",\"owner\":{\"zpuid\":\"4000000002055\"},\"is_public_project\":false,\"start_date\":\"2023-12-20\",\"end_date\":\"2024-12-20\",\"completed_time\":\"2025-12-30T18:30:00.000Z\",\"status\":{\"id\":\"4000000062001\"},\"layout\":{\"id\":\"4000000062001\"},\"added_via\":\"api\",\"is_rollup_project\":false,\"budget_info\":{\"billing_method\":\"project_hours\",\"budget_type\":\"based_on_project\",\"tracking_method\":\"project_hours\",\"currency\":\"USD\",\"cost_budget\":{\"amount\":50000.0},\"hourly_budget\":\"30:00\",\"rate_per_hour\":{\"amount\":945.25},\"cost_budget_threshold\":{\"amount\":50000.0},\"hourly_budget_threshold\":\"20:00\",\"fixed_cost\":{\"amount\":50000.0},\"cost_per_hour\":{\"amount\":510.75},\"revenue_budget\":{\"amount\":50000.0}},\"project_group\":{\"id\":\"4000000062001\"},\"tags\":[{\"add\":[{\"id\":\"4000000062001\"}],\"remove\":[{\"id\":\"4000000062001\"}],\"id\":\"4000000062001\"}],\"color\":\"#4573d2\",\"business_hours_id\":\"7000000197013\"}")
    req, _ := http.NewRequest("PATCH", "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166", payload)
    req.Header.Add("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa")
    req.Header.Add("Content-Type", "application/json")

    resp, _ := http.DefaultClient.Do(req)
    defer resp.Body.Close()
    body, _ := io.ReadAll(resp.Body)
    fmt.Println(string(body))
}
PATCH https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166 HTTP/1.1
Host: https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166
Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa
Content-Type: application/json

{"name":"Website Redesign","description":"Redesign the company website with new branding","project_type":"active","owner":{"zpuid":"4000000002055"},"is_public_project":false,"start_date":"2023-12-20","end_date":"2024-12-20","completed_time":"2025-12-30T18:30:00.000Z","status":{"id":"4000000062001"},"layout":{"id":"4000000062001"},"added_via":"api","is_rollup_project":false,"budget_info":{"billing_method":"project_hours","budget_type":"based_on_project","tracking_method":"project_hours","currency":"USD","cost_budget":{"amount":50000.0},"hourly_budget":"30:00","rate_per_hour":{"amount":945.25},"cost_budget_threshold":{"amount":50000.0},"hourly_budget_threshold":"20:00","fixed_cost":{"amount":50000.0},"cost_per_hour":{"amount":510.75},"revenue_budget":{"amount":50000.0}},"project_group":{"id":"4000000062001"},"tags":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"color":"#4573d2","business_hours_id":"7000000197013"}
HttpClientBuilder httpClientBuilder = HttpClientBuilder.create();

SSLContext sslContext = SSLContext.getDefault();
SSLConnectionSocketFactory sslConnectionSocketFactory = new SSLConnectionSocketFactory(sslContext, NoopHostnameVerifier.INSTANCE);
CloseableHttpClient httpclient = httpClientBuilder.setSSLSocketFactory(sslConnectionSocketFactory).build();

URIBuilder uriBuilder = new URIBuilder("https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166");
HttpUriRequest requestObj = new HttpPatch(uriBuilder.build());
requestObj.addHeader("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");

HttpEntityEnclosingRequestBase requestBase = (HttpEntityEnclosingRequestBase) requestObj;
String requestBody = "{\"name\":\"Website Redesign\",\"description\":\"Redesign the company website with new branding\",\"project_type\":\"active\",\"owner\":{\"zpuid\":\"4000000002055\"},\"is_public_project\":false,\"start_date\":\"2023-12-20\",\"end_date\":\"2024-12-20\",\"completed_time\":\"2025-12-30T18:30:00.000Z\",\"status\":{\"id\":\"4000000062001\"},\"layout\":{\"id\":\"4000000062001\"},\"added_via\":\"api\",\"is_rollup_project\":false,\"budget_info\":{\"billing_method\":\"project_hours\",\"budget_type\":\"based_on_project\",\"tracking_method\":\"project_hours\",\"currency\":\"USD\",\"cost_budget\":{\"amount\":50000.0},\"hourly_budget\":\"30:00\",\"rate_per_hour\":{\"amount\":945.25},\"cost_budget_threshold\":{\"amount\":50000.0},\"hourly_budget_threshold\":\"20:00\",\"fixed_cost\":{\"amount\":50000.0},\"cost_per_hour\":{\"amount\":510.75},\"revenue_budget\":{\"amount\":50000.0}},\"project_group\":{\"id\":\"4000000062001\"},\"tags\":[{\"add\":[{\"id\":\"4000000062001\"}],\"remove\":[{\"id\":\"4000000062001\"}],\"id\":\"4000000062001\"}],\"color\":\"#4573d2\",\"business_hours_id\":\"7000000197013\"}";
requestBase.setEntity(new StringEntity(requestBody, HTTP.UTF_8));

HttpResponse response = httpclient.execute(requestObj);

HttpEntity responseEntity = response.getEntity();
Object responseObject = EntityUtils.toString(responseEntity);
String responseString = responseObject.toString();
const url = 'https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166';

const options = {
  method: 'PATCH',
  headers: {
    'Authorization': 'Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa',
    'Content-Type': 'application/json'
  },
  body: JSON.stringify({"name":"Website Redesign","description":"Redesign the company website with new branding","project_type":"active","owner":{"zpuid":"4000000002055"},"is_public_project":false,"start_date":"2023-12-20","end_date":"2024-12-20","completed_time":"2025-12-30T18:30:00.000Z","status":{"id":"4000000062001"},"layout":{"id":"4000000062001"},"added_via":"api","is_rollup_project":false,"budget_info":{"billing_method":"project_hours","budget_type":"based_on_project","tracking_method":"project_hours","currency":"USD","cost_budget":{"amount":50000.0},"hourly_budget":"30:00","rate_per_hour":{"amount":945.25},"cost_budget_threshold":{"amount":50000.0},"hourly_budget_threshold":"20:00","fixed_cost":{"amount":50000.0},"cost_per_hour":{"amount":510.75},"revenue_budget":{"amount":50000.0}},"project_group":{"id":"4000000062001"},"tags":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"color":"#4573d2","business_hours_id":"7000000197013"})
};

fetch(url, options)
  .then(response => response.json())
  .then(data => console.log(data))
  .catch(error => console.error(error));
{"name":"Website Redesign","description":"Redesign the company website with new branding","project_type":"active","owner":{"zpuid":"4000000002055"},"is_public_project":false,"start_date":"2023-12-20","end_date":"2024-12-20","completed_time":"2025-12-30T18:30:00.000Z","status":{"id":"4000000062001"},"layout":{"id":"4000000062001"},"added_via":"api","is_rollup_project":false,"budget_info":{"billing_method":"project_hours","budget_type":"based_on_project","tracking_method":"project_hours","currency":"USD","cost_budget":{"amount":50000.0},"hourly_budget":"30:00","rate_per_hour":{"amount":945.25},"cost_budget_threshold":{"amount":50000.0},"hourly_budget_threshold":"20:00","fixed_cost":{"amount":50000.0},"cost_per_hour":{"amount":510.75},"revenue_budget":{"amount":50000.0}},"project_group":{"id":"4000000062001"},"tags":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"color":"#4573d2","business_hours_id":"7000000197013"}
import java.net.HttpURLConnection
import java.net.URL
import okhttp3.HttpUrl.Companion.toHttpUrl

fun main() {
    val url = URL("https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166")
    val conn = url.openConnection() as HttpURLConnection
    conn.requestMethod = "PATCH"
    conn.setRequestProperty("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa")
    conn.setRequestProperty("Content-Type", "application/json")
    conn.doOutput = true
    conn.outputStream.bufferedWriter().use { it.write("""{"name":"Website Redesign","description":"Redesign the company website with new branding","project_type":"active","owner":{"zpuid":"4000000002055"},"is_public_project":false,"start_date":"2023-12-20","end_date":"2024-12-20","completed_time":"2025-12-30T18:30:00.000Z","status":{"id":"4000000062001"},"layout":{"id":"4000000062001"},"added_via":"api","is_rollup_project":false,"budget_info":{"billing_method":"project_hours","budget_type":"based_on_project","tracking_method":"project_hours","currency":"USD","cost_budget":{"amount":50000.0},"hourly_budget":"30:00","rate_per_hour":{"amount":945.25},"cost_budget_threshold":{"amount":50000.0},"hourly_budget_threshold":"20:00","fixed_cost":{"amount":50000.0},"cost_per_hour":{"amount":510.75},"revenue_budget":{"amount":50000.0}},"project_group":{"id":"4000000062001"},"tags":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"color":"#4573d2","business_hours_id":"7000000197013"}""") }

    val response = conn.inputStream.bufferedReader().readText()
    println(response)
}
NSURL *url = [NSURL URLWithString:@"https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166"];
NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:url];
[request setHTTPMethod:@"PATCH"];
[request setValue:@"Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa" forHTTPHeaderField:@"Authorization"];
[request setValue:@"application/json" forHTTPHeaderField:@"Content-Type"];
[...]
